/***************************************************************************
                          imconferm.cpp  -  description
                             -------------------
    begin                : Fri Mar 10 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 * ImConferm is a dialog box that asks the user what person they would like
 * to IM.  When ok is clicked it emits a signal to chat with that user.
 ***************************************************************************/

#include "imconfirm.h"

/***************************************************************************
 * Constructor
 ***************************************************************************/
ImConferm::ImConferm(QWidget *parent, const char *name, QString InputName) : QDialog(parent,name,false,WDestructiveClose){
  Name = InputName;
  initDialog();
  UserName->setText( Name );
  connect(cancel, SIGNAL(clicked()), this, SLOT(cancelClicked()));
  connect(ok, SIGNAL(clicked()), this, SLOT(okClicked()));
  connect(UserName, SIGNAL(returnPressed()), this, SLOT(moveToPass()));
}

/***************************************************************************
 * Deconstructor
 ***************************************************************************/
ImConferm::~ImConferm(){
}

/***************************************************************************
 * Widget Creator
 ***************************************************************************/
void ImConferm::ImConferm::initDialog(){
  this->resize(215,60);
  this->setMinimumSize(215,60);
  this->setMaximumSize(215,60);
  QLabel_1= new QLabel(this,"NoName");
  QLabel_1->setGeometry(5,5,25,20);
  QLabel_1->setMinimumSize(0,0);
  QLabel_1->setText("IM:");

  UserName= new QLineEdit(this,"NoName");
  UserName->setGeometry(25,5,185,20);
  UserName->setMinimumSize(0,0);
	UserName->setFocus();

  ok= new QPushButton(this,"NoName");
  ok->setGeometry(160,30,50,25);
  ok->setMinimumSize(0,0);
  ok->setText("OK");

  cancel= new QPushButton(this,"NoName");
  cancel->setGeometry(95,30,60,25);
  cancel->setMinimumSize(0,0);
  cancel->setText("Cancel");
}

/***************************************************************************
 * Moves the Cursor to the Password field if return is hit
 ***************************************************************************/
void ImConferm::moveToPass(){
  ok->setFocus();
}

/***************************************************************************
 * Sends a signal to tell the buddy list to chat with this user and close the window.
 ***************************************************************************/
void ImConferm::okClicked(){
  emit (ChatWithBuddyConfermed(UserName->text()));
  this->done(true);
}

/***************************************************************************
 * Closes the window and cancels the connect
 * Occurs when the Cancel Button is hit.
 ***************************************************************************/
void ImConferm::cancelClicked(){
  this->done(true);
}

// imconferm.cpp
#include "imconfirm.moc"
