/***************************************************************************
                                info.cpp
			                    -------------------
    begin                : Mon Jul 31 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "info.h"

/***************************************************************************
 * Constructor
 ***************************************************************************/
Info::Info(QWidget *parent, const char *name) : QDialog(parent,name,false,WDestructiveClose){
  initDialog();
  connect(Close, SIGNAL(clicked()), this, SLOT(closeWindow()));
}

/***************************************************************************
 * Deconstructor
 ***************************************************************************/
Info::~Info(){
}

/******************************************************************************
 * Close out the client.
 ******************************************************************************/
void Info::closeEvent(QCloseEvent *) {
  // Close window
  this->done(1);
}

/***************************************************************************
 * Create the GUI
 ***************************************************************************/
void  Info::initDialog(){
  this->resize(450,450);
  this->setMinimumSize(300,190);
  Information= new KaimTextBrowser(this,"NoName");
  Information->setGeometry(10,10,280,240);
  Information->setMinimumSize(0,0);
  Information->setText("");
  connect(Information, SIGNAL(gotoURL(QString)), this, SLOT(urlClicked(QString)));

  Close= new QPushButton(this,"NoName");
  Close->setGeometry(190,260,100,30);
  Close->setMinimumSize(0,0);
  Close->setText("Close");

}
/***************************************************************************
 * Get the page from the web using wget. 
 ***************************************************************************/
void Info::addToWindow(QString data){
  system("wget -q -O /tmp/kaiminfo " + data);
  QString settingsFile = "/tmp/kaiminfo";
  QFile file(settingsFile);
  QString info = "<qt>";
  if (file.open(IO_ReadWrite))
  {
    QTextStream stream(&file);
    while(!stream.eof()){
      info += stream.readLine();
      info += "\n";
    }
    file.close();
    file.remove();

    
    int titleEnd = info.find("</TITLE>");
    info = info.mid(titleEnd + 14, info.length() -14);
    info = QString("<html>") + info; 
    info.replace( QRegExp("free_icon.gif"), DATADIR "/icons/buddy_oscar.png" );
    info.replace( QRegExp("aol_icon.gif"), DATADIR "/icons/buddy_aol.png" );
    info.replace( QRegExp("admin_icon.gif"), DATADIR "/icons/buddy_admin.png" );
    info.replace( QRegExp("dt_icon.gif"), DATADIR "/icons/buddy_unknown.png" );
    Information->setText(info);
  }
  else
    QMessageBox::information(0, "Error",("Could not open info.\nMake sure wget is installed."), QMessageBox::Ok);
}

/******************************************************************************
 * Open this url in a web browser.
 ******************************************************************************/
void Info::urlClicked(QString url){
  browser->openURL(url);
}


/***************************************************************************
 * Close the window once the close button is hit. 
 ***************************************************************************/
void Info::closeWindow(){
  this->done(1);
}

/***************************************************************************
 * Resizes the object in the window, when the window is resized.
 ***************************************************************************/
void Info::resizeEvent( QResizeEvent *e ){
  Information->setGeometry(10,10,this->width()-20,this->height()-60);
  Close->setGeometry(this->width()-110,this->height()-40,100,30);
}

// info.cpp
#include "info.moc"
