#ifndef KAIMAPPLICATION_H
#define KAIMAPPLICATION_H

#include <qapplication.h>
#include "kaimiconloader.h"

class KaimApplication : public QApplication
{
	Q_OBJECT

	public:
		// Pass command line parameters
		// They goes straight through to the QApplication
		KaimApplication(int, char **);
		~KaimApplication();

		// Convenience function, in case more is added to KaimApplication
		static KaimApplication *kaimApplication(void);

		// This is the whole point of KaimApplication
		// Every part of the app has to use the same KaimIconLoader,
		// otherwise memory is wasted.
		static KaimIconLoader &iconLoader(void);
	private:
		static KaimIconLoader *myIconLoader;
};

// Here's a convenience definition
inline const QPixmap &Icon(const QString &name)
{
	return KaimApplication::iconLoader().loadIcon(name);
}

#endif
