// kaimiconloader.cpp
//
// Kaim
//
// Copyright 2000 by Neil Stevens <multivac @ fcmail.com>
//
// Licensed under the GNU Library General Public License

#include "kaimiconloader.h"

KaimIconLoader::KaimIconLoader(const QString &path, int hasharraysize)
{
	cache.resize(hasharraysize);
        cache.setAutoDelete(true);
	iconPath = path;
}
KaimIconLoader::~KaimIconLoader()
{
	// ensure that all the QPixmaps are deleted
	// I don't know if this is necessary, but it doesn't hurt
	clearCache();
}
void KaimIconLoader::clearCache(void)
{
	cache.clear();
}
void KaimIconLoader::setIconPath(const QString &path)
{
	clearCache();
	iconPath = path;
}
const QPixmap &KaimIconLoader::loadIcon(const QString &name)
{
	if(!cache[name]) cache.insert(name, new QPixmap(iconPath + name + ".png"));
	return *cache[name];
}	
