/***************************************************************************
                         				kaimviewlist.h
                             -------------------
    begin                : Fri Feb 15 2001
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KAIMVIEWLIST_H
#define KAIMVIEWLIST_H

#include <qwidget.h>
#include <qlistview.h>
#include <qevent.h>
#include <qcursor.h>
#include "editbox.h"
/**
  *@author Benjamin Meyer
  */

class KaimListView : public QListView {
  Q_OBJECT

  signals:
    void moveItem(QListViewItem *item, QListViewItem *newFolder);
  
  public:
    KaimListView(QWidget *parent=0, const char *name=0);
    ~KaimListView();
		EditBox *buddyEdit;

	private:
	  QListViewItem *currentSelectedItem;
	  QCursor internalCursor;	
  protected:	
    void contentsMouseReleaseEvent(QMouseEvent* event);
    void focusOutEvent( QFocusEvent * );

	private slots:
		void itemPressed(QListViewItem *item);
		bool checkIfFolder(QListViewItem* selected);	
};
#endif
// KaimListView.h

