/***************************************************************************
                          				main.cpp
                             -------------------
    begin                : Sun Feb 13 01:05:24 EST 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kaim.h"
#include "kaimapplication.h"

#include <string.h>

int main(int argc, char *argv[]){
  bool disableAutoCheck = false;
	if (argc >= 0){
    if (strcmp(argv[1],"-help")==0 || strcmp(argv[1],"--help")==0 || strcmp(argv[1],"-?")==0){
    printf("
Usage: kaim [OPTION...]\n"
"\n"
"Help options\n"
"  -?, -help --help            Show this help message\n"
"\n"
"Kaim Options\n"
"  --disable-new-version-check Kaim will not check for a new version on login.\n"
"\n"
"QT Options\n"
"  -style=[style]              Sets the application GUI style/theme. Possible\n"
"                              values are motif, windows, and platinum.\n"
"  -session=[session]          Restores the application from an earlier session.\n"    
"\n"
"QT X11 Options\n"
"  -display [display]          Sets the X display (default is $DISPLAY).\n" 
"  -geometry [geometry]        Sets the client geometry of the main widget.\n" 
"  -fn or -font [font]         Defines the application font.\n"
"  -bg or -background [color]  Sets the default background color and an\n"
"                              application palette (light and dark shades are \n"
"                              calculated).\n"
"  -fg or -foreground [color]  Sets the default foreground color.\n"
"  -btn or -button [color]     Sets the default button color.\n"
"  -name [name]                Sets the application name.\n"
"  -title [title]              Sets the application title (caption).\n"
"  -visual [TrueColor]         Forces the application to use a TrueColor visual\n"
"                              on an 8-bit display.\n"
"  -ncols [count]              Limits the number of colors allocated in the\n"
"                              color cube on a 8-bit display, if the application\n"
"                              is using the QApplication::ManyColor color\n"
"                              specification.  If count is 216 then a 6x6x6\n"
"                              color cube is used (ie. 6 levels of red, 6 of\n"
"                              green, and 6 of blue); for other values, a cube\n"
"                              approximately proportional to a 2x3x1 cube\n"
"                              is used.\n"
"  -cmap                       Causes the application to install a private color\n"
"                              map on an 8-bit display.\n"
);
      exit(1);    
    }
	  if (strcmp(argv[1],"--disable-new-version-check")==0){
      disableAutoCheck = true;
		}
  }
  KaimApplication a(argc, argv);
  Kaim *kaim = new Kaim();
	kaim->autoUpdateCheck = disableAutoCheck;
  QObject::connect(kaim, SIGNAL(quit()), &a, SLOT(quit()));
  kaim->show();
  a.setMainWidget(kaim);
  return a.exec();
}
