/***************************************************************************
                          newawaymessage.cpp  -  description
                             -------------------
    begin                : Tue Apr 11 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "newawaymessage.h"

/***************************************************************************
 * Constructor
 ***************************************************************************/
NewAwayMessage::NewAwayMessage(QWidget *parent, const char *name) : QDialog(parent,name,false,WDestructiveClose){
  initDialog();
  connect(cancel, SIGNAL(clicked()), this, SLOT(cancelClicked()));
  connect(ok, SIGNAL(clicked()), this, SLOT(okClicked()));
}

/***************************************************************************
 * Deconstructor
 ***************************************************************************/
NewAwayMessage::~NewAwayMessage(){
}

/***************************************************************************
 * Sends a signal to tell the buddy list to chat with this user and close the window.
 ***************************************************************************/
void NewAwayMessage::okClicked(){
  if (title->text().isEmpty() )
    QMessageBox::information(this, "Message",("You must have a title."), QMessageBox::Ok);
  else{
    QString text = message->text();
    QString lastLetter = text.mid(text.length()-1,1);
    while (text.length() > 0 && lastLetter == "\n"){
      text = text.mid(0,text.length()-1);
      lastLetter = text.at(text.length()-1);
    }
    message->setText(text);
  
    //emit (ChatWithBuddyConfermed(UserName->text()));
		i_aimSettings->mapAwayMessages->insert(title->text(), message->text());
    if (setAwayNow->isChecked()){
      emit (makeAwayNow(title->text()));
		}
    this->done(1);
  }  
}

/***************************************************************************
 * Closes the window and cancels the connect
 * Occurs when the Cancel Button is hit.
 ***************************************************************************/
void NewAwayMessage::cancelClicked(){
  this->done(1);
}

void  NewAwayMessage::initDialog(){
  this->resize(280,205);
  this->setMinimumSize(0,0);
  message= new QMultiLineEdit(this,"NoName");
  message->setGeometry(10,40,260,120);
  message->setMinimumSize(0,0);
  message->setText("");
  message->setWrapPolicy( QMultiLineEdit::Anywhere );
	
  setAwayNow= new QCheckBox(this,"NoName");
  setAwayNow->setGeometry(10,170,110,20);
  setAwayNow->setMinimumSize(0,0);
  setAwayNow->setText("Set away now");
  setAwayNow->setChecked(true);

  ok= new QPushButton(this,"NoName");
  ok->setGeometry(120,170,70,25);
  ok->setMinimumSize(0,0);
  ok->setText("Ok");

  cancel= new QPushButton(this,"NoName");
  cancel->setGeometry(200,170,70,25);
  cancel->setMinimumSize(0,0);
  cancel->setText("Cancel");

  title= new QLineEdit(this,"NoName");
  title->setGeometry(40,10,230,20);
  title->setMinimumSize(0,0);
  title->setText("");

  QLabel_1= new QLabel(this,"NoName");
  QLabel_1->setGeometry(10,10,30,20);
  QLabel_1->setMinimumSize(0,0);
  QLabel_1->setFont(QFont("helvetica", 12, 75));
  QLabel_1->setText("Title");

}
#include "newawaymessage.moc"
// newawaymessage.cpp
