/***************************************************************************
                               ChatOptionsImp.h
                             -------------------
    begin                : Tuesday Nov 14 2000
    copyright            : (C) 2000 Benjamin Meyer 
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

#ifndef CHATOPTIONSIMP_H
#define CHATOPTIONSIMP_H

#include <chatoptions.h>
#include <chattoolbaroptionsimp.h>
#include <setup.h>

/**
  *@author Benjamin Meyer
  */

class ChatOptionsImp : public ChatOptions  {

Q_OBJECT
	
signals:
  void saveSettings();
  void chatToolbarUpdated();

public:
  ChatOptionsImp(QWidget *parent=0, const char *name=0, settings *aimSettings=0);
  ~ChatOptionsImp();

public slots:
  void updateData();
  void getData();

private slots:
  void openToolbarOptions(); 
  void changeUserTextColor();
  void changeBuddyTextColor();
  void changeUserNameColor();
  void changeBuddyNameColor();
  void changeBuddyBGColor();
  void changeUserBGColor();
  void setDefaultBuddyColors();
  void setDefaultUserColors();

private:
  settings *i_aimSettings;
  ChatToolbarOptionsImp *toolbarOptions;

};

#endif

// ChatOptionsImp.h
