/***************************************************************************
                         ChatToolbarsOptionsImp.cpp
                             -------------------
    begin                : Tuesday Nov 14 2000
    copyright            : (C) 2000 Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/


#include "chattoolbaroptionsimp.h"
#include <qcombobox.h>
#include <qcheckbox.h>


/******************************************************************************
 * Constructor
 ******************************************************************************/
ChatToolbarOptionsImp::ChatToolbarOptionsImp(QWidget *parent, const char *name, settings *aimSettings) : ChatToolbarsOptions ( parent,name,false ){
  i_aimSettings = aimSettings;
  chat_view_text->setChecked(i_aimSettings->chatToolBarSettings->view_text);
  chat_view_chat->setChecked(i_aimSettings->chatToolBarSettings->view_chat);
  chat_view_preview->setChecked(i_aimSettings->chatToolBarSettings->view_prev);

  if (i_aimSettings->chatToolBarSettings->view_prev == true)
    chat_prev_loc->setEnabled(true);
  else
    chat_prev_loc->setEnabled(false);	
  if (i_aimSettings->chatToolBarSettings->view_chat == true)
    chat_chat_loc->setEnabled(true);
  else
    chat_chat_loc->setEnabled(false);	
  if (i_aimSettings->chatToolBarSettings->view_text == true)
    chat_text_loc->setEnabled(true);
  else
    chat_text_loc->setEnabled(false);	
  
  chat_text_loc->setCurrentItem(i_aimSettings->chatToolBarSettings->loc_text);
  chat_chat_loc->setCurrentItem(i_aimSettings->chatToolBarSettings->loc_chat);
  chat_prev_loc->setCurrentItem(i_aimSettings->chatToolBarSettings->loc_prev);
  
  chat_text_bold->setChecked(i_aimSettings->chatToolBarSettings->text_bold);
  chat_text_italic->setChecked(i_aimSettings->chatToolBarSettings->text_italic);
  chat_text_underline->setChecked(i_aimSettings->chatToolBarSettings->text_underline);
  chat_text_fontdown->setChecked(i_aimSettings->chatToolBarSettings->text_fontdown);
  chat_text_fontnorm->setChecked(i_aimSettings->chatToolBarSettings->text_fontnormal);
  chat_text_fontup->setChecked(i_aimSettings->chatToolBarSettings->text_fontbig);
  chat_text_bgcolor->setChecked(i_aimSettings->chatToolBarSettings->text_bgcolor);
  chat_text_textcolor->setChecked(i_aimSettings->chatToolBarSettings->text_pencolor);
  chat_text_link->setChecked(i_aimSettings->chatToolBarSettings->text_link);
  
  chat_chat_clear->setChecked(i_aimSettings->chatToolBarSettings->chat_clear);
  chat_chat_save->setChecked(i_aimSettings->chatToolBarSettings->chat_save);
  chat_chat_print->setChecked(i_aimSettings->chatToolBarSettings->chat_print);
  chat_chat_time->setChecked(i_aimSettings->chatToolBarSettings->chat_time);
  chat_chat_log->setChecked(i_aimSettings->chatToolBarSettings->chat_log);
  chat_chat_sound->setChecked(i_aimSettings->chatToolBarSettings->chat_sound);
  chat_chat_addremove->setChecked(i_aimSettings->chatToolBarSettings->chat_remove);
  chat_chat_warn->setChecked(i_aimSettings->chatToolBarSettings->chat_warn);
  chat_chat_block->setChecked(i_aimSettings->chatToolBarSettings->chat_block);
  chat_chat_info->setChecked(i_aimSettings->chatToolBarSettings->chat_info);  
 

}

/******************************************************************************
 * Deconstructor
 ******************************************************************************/
ChatToolbarOptionsImp::~ChatToolbarOptionsImp(){
}

/******************************************************************************
 * Copy the settings to the dialogs
 ******************************************************************************/
void ChatToolbarOptionsImp::updateData(){
  i_aimSettings->chatToolBarSettings->view_text = chat_view_text->isChecked();
  i_aimSettings->chatToolBarSettings->view_chat = chat_view_chat->isChecked();
  i_aimSettings->chatToolBarSettings->view_prev = chat_view_preview->isChecked();
  
  i_aimSettings->chatToolBarSettings->loc_text = chat_text_loc->currentItem();
  i_aimSettings->chatToolBarSettings->loc_chat = chat_chat_loc->currentItem();
  i_aimSettings->chatToolBarSettings->loc_prev = chat_prev_loc->currentItem();
  
  i_aimSettings->chatToolBarSettings->text_bold = chat_text_bold->isChecked();
  i_aimSettings->chatToolBarSettings->text_italic = chat_text_italic->isChecked();
  i_aimSettings->chatToolBarSettings->text_underline = chat_text_underline->isChecked();
  i_aimSettings->chatToolBarSettings->text_fontdown = chat_text_fontdown->isChecked();
  i_aimSettings->chatToolBarSettings->text_fontnormal = chat_text_fontnorm->isChecked();
  i_aimSettings->chatToolBarSettings->text_fontbig = chat_text_fontup->isChecked();
  i_aimSettings->chatToolBarSettings->text_bgcolor = chat_text_bgcolor->isChecked();
  i_aimSettings->chatToolBarSettings->text_pencolor = chat_text_textcolor->isChecked();
  i_aimSettings->chatToolBarSettings->text_link = chat_text_link->isChecked();
  
  i_aimSettings->chatToolBarSettings->chat_clear = chat_chat_clear->isChecked();
  i_aimSettings->chatToolBarSettings->chat_save = chat_chat_save->isChecked();
  i_aimSettings->chatToolBarSettings->chat_print = chat_chat_print->isChecked();
  i_aimSettings->chatToolBarSettings->chat_time = chat_chat_time->isChecked();
  i_aimSettings->chatToolBarSettings->chat_log = chat_chat_log->isChecked();
  i_aimSettings->chatToolBarSettings->chat_sound = chat_chat_sound->isChecked();
  i_aimSettings->chatToolBarSettings->chat_remove = chat_chat_addremove->isChecked();
  i_aimSettings->chatToolBarSettings->chat_warn = chat_chat_warn->isChecked();
  i_aimSettings->chatToolBarSettings->chat_block = chat_chat_block->isChecked();
  i_aimSettings->chatToolBarSettings->chat_info = chat_chat_info->isChecked();  
  
  emit (saveSettings());
}

//ChatToolbarsOptionsImp.cpp
