/***************************************************************************
                               kaimdialogs.h
                             -------------------
    begin                : Sun Feb 13 01:05:24 EST 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 * Options Widget Brings up the setup widget that has tabs and allows you to
 * configure the program just about any way you want.
 * I added saving and putting in data and functionallity (Browse...)
 ***************************************************************************/

/*******************************************************************/
/* Original file inspired by-                                      */
/* K Instant Messenger -- A KDE-based AOL Instant Messengr Client  */
/* Copyright (C) 1999 Aaron Traas and Jeremy Thompson              */
/*                                                                 */
/* For more information regaurding K Instant Messenger, contact:   */
/*    - EMAIL: adt6247@megahertz.njit.edu                          */
/*******************************************************************/

#include "kaimdialogs.h"
#include "kaimapplication.h"

ConfigWindow::ConfigWindow( QWidget * parent, const char * name , settings *aimSettings, TAim *i_connection )
  : KaimJanusWidget /*QTabDialog*/( parent, name, KaimJanusWidget::IconList /*TreeList */){

  setFixedSize( 548, 525 );

	//TODO: Figure out a better way to handle the positioning/clickage of the
	//buttons Ok, Apply, and Cancel.  Right now, each settings frame has its own
	//"okPanel" that handles these buttons, which seems to me the best way to do
	//it.  Another way would be to include the buttons in each setting page's class,
	//but I was out to not alter those, and the way I did it is the only way to
	//do that.  Is there another way to do this?
	QFrame *networkFrame = addPage("Network", "Network Settings",
				QPixmap(Icon("config_network")));
	networkFrame->setFixedSize(460, 500);
	network = new NetworkOptionsImp( networkFrame, "NetworkPage", aimSettings);
	network->setFixedSize(450, 400);
	okPanel2 = new OkApplyCancelPanel( networkFrame, "okPanel2");
	okPanel2->setGeometry( 0, 450, 450, 50);
	connect(okPanel2, SIGNAL( okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect(okPanel2, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect(okPanel2, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );
	
	QFrame *chatFrame = addPage("Chat", "Chat Settings", QPixmap(Icon("config_general")));
	chatFrame->setFixedSize(460, 500);
	okPanel6 = new OkApplyCancelPanel( chatFrame, "okPanel6");
	okPanel6->setGeometry( 0, 450, 450, 50);
        
	chat = new ChatOptionsImp(chatFrame, "ChatPage", aimSettings);
	chat->setFixedSize(450, 450);
	connect(chat, SIGNAL(chatToolbarUpdated()), this, SIGNAL(chatToolbarUpdated()));
	connect(okPanel6, SIGNAL( okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect(okPanel6, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect(okPanel6, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );

  QFrame *mainFrame = addPage("Main Window", "Main Window Settings", QPixmap(Icon("config_main")));
	chatFrame->setFixedSize(460, 500);
	okPanel8 = new OkApplyCancelPanel( mainFrame, "okPanel8");
	okPanel8->setGeometry( 0, 450, 450, 50);
        
	main = new MainWindowOptionsImp(mainFrame, "MainPage", aimSettings);
	main->setFixedSize(450, 450);
	connect(okPanel8, SIGNAL( okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect(okPanel8, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect(okPanel8, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );
	
	QFrame *soundFrame = addPage("Sound", "Sound Settings", 
				QPixmap(Icon("config_sound")));
	soundFrame->setFixedSize(460, 500);
	sound = new SoundOptionsImp( soundFrame, "SoundPage", aimSettings);
	sound->setFixedSize(450, 400);
	okPanel1 = new OkApplyCancelPanel( soundFrame, "okPanel1");
	okPanel1->setGeometry( 0, 450, 460, 50);
	connect(okPanel1, SIGNAL( okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect(okPanel1, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect(okPanel1, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );
	
	QFrame *denyFrame = addPage("Permit/Deny", "Permit/Deny Settings",
				QPixmap(Icon("config_deny")));
	denyFrame->setFixedSize(460, 500);
	deny = new DenyPage( denyFrame, "DenyPage", aimSettings);
	deny->setFixedSize(450, 400);
	okPanel3 = new OkApplyCancelPanel( denyFrame, "okPanel3");
	okPanel3->setGeometry( 0, 450, 450, 50);
	deny->connection = i_connection;
	connect(okPanel3, SIGNAL( okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect(okPanel3, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect(okPanel3, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );

	QFrame *awayFrame = addPage("Away", "Away Settings",
				QPixmap(Icon("config_away")));
	awayFrame->setFixedSize(460, 500);
	away = new AwayWindowOptionsImp( awayFrame, "AwayPage", aimSettings);
	away->setFixedSize(450, 400);
	okPanel4 = new OkApplyCancelPanel( awayFrame, "okPanel4");
	okPanel4->setGeometry( 0, 450, 450, 50);
	connect(okPanel4, SIGNAL( okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect(okPanel4, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect(okPanel4, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );

	QFrame *profileFrame = addPage("Profile", "Profile Settings",
				QPixmap(Icon("config_profile")));
	profileFrame->setFixedSize(460, 500);
	profile = new ProfileOptionsImp( profileFrame, "ProfilePage", aimSettings);
	profile->setFixedSize(450, 400);
	okPanel5 = new OkApplyCancelPanel( profileFrame, "okPanel5");
	okPanel5->setGeometry( 0, 450, 450, 50);
	connect(okPanel5, SIGNAL( okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect(okPanel5, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect(okPanel5, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );

	
	/*QFrame *eventsFrame = addPage("Events", "Responses to Events",
        				QPixmap(Icon("config_general")));
	eventsFrame->setFixedSize(460,500);
	
	events = new  EventsPage( eventsFrame, "EventsPage", aimSettings);
	*/
	events = new  EventsPage( 0, "EventsPage", aimSettings);
	events->setFixedSize(450,400);
	/*okPanel7 = new OkApplyCancelPanel( eventsFrame, "okPanel7");
	okPanel7->setGeometry( 0, 430, 450 , 470);
	connect(okPanel7, SIGNAL(okPressed() ), this, SLOT( sendDataAndCloseDialog() ) );
	connect (okPanel7, SIGNAL( applyPressed() ), this, SLOT( sendData() ) );
	connect (okPanel7, SIGNAL( cancelPressed() ), this, SLOT( closeDialog() ) );
	*/
	/*
  addTab(sound = new SoundPage( this, "SoundPage", aimSettings ), "Sound" );
  addTab(network =new NetworkPage( this, "NetworkPage", aimSettings ), "Network" );
  addTab(deny = new DenyPage( this, "DenyPage", aimSettings ), "Permit/Deny" );
  addTab(away = new AwayPage( this, "AwayPage", aimSettings ), "Away" );
  addTab(profile = new ProfilePage( this, "ProfilePage", aimSettings ), "Profile" );
  addTab(general = new GeneralPage( this, "GeneralPage", aimSettings ), "General" );
	*/
}

void ConfigWindow::updateData(){
  sound->updateData();
  network->updateData();
  deny->updateData();
  away->updateData();
  profile->updateData();
  chat->updateData();
	main->updateData();
}

void ConfigWindow::sendDataAndCloseDialog(){
  sendData();
  this->hide();
  //this->close(1);
}

void ConfigWindow::closeDialog(){
  this->hide();
  //this->close(1);
}

void ConfigWindow::sendData(){
  // get Sound
  sound->getData();
  // get Network
  network->getData();
  // get Deny
  deny->getData();
  // get Away
  away->getData();
  // get Profile
  profile->getData();
  // get Chat
  chat->getData();
	// get main
	main->getData();

  emit (dataUpdated());
  emit (exiting());
}

//===============================================================
// DenyPage
//===============================================================

DenyPage::DenyPage( QWidget * parent, const char * name , settings *aimSettings)
  : QWidget( parent, name )
{
  i_aimSettings = aimSettings;
  access = new QButtonGroup( "Accessibility Options", this );
  access->setExclusive( TRUE );
  access_anyone = new QRadioButton( "Allow anyone to IM me.", access );
  access_buddy = new QRadioButton( "Allow only buddies on my permit list to IM me.", access );
  access_ask = new QRadioButton( "Allow anyone not on the Deny list to IM me.", access );
  
  access_anyone->setGeometry(10, 15, 400, 20 );
  access_buddy->setGeometry(10, 40, 400, 20 );
  access_ask->setGeometry(10, 65, 400, 20 );

  deny = new QGroupBox( "Permit/Deny lists", this );
  QLabel *l = new QLabel( "Permit:", deny );
  l->setGeometry( 10, 15, 60, 20 );
  deny_list_permit = new QListBox( deny );
  deny_label = new QLabel("Deny:", deny );
  deny_list_deny = new QListBox( deny );
  deny_add_permit = new QPushButton( "Add...", deny );
  deny_delete_permit = new QPushButton( "Delete", deny );
  deny_add_deny = new QPushButton( "Add...", deny );
  deny_delete_deny = new QPushButton( "Delete", deny );  
  connect(access_anyone, SIGNAL(toggled(bool)), this, SLOT(toggle_anyone(bool)));
  connect(access_buddy, SIGNAL(toggled(bool)), this, SLOT(toggle_buddy(bool)));
  connect(access_ask, SIGNAL(toggled(bool)), this, SLOT(toggle_ask(bool)));

  connect(deny_add_permit, SIGNAL(clicked()), this, SLOT(addPermit()));
  connect(deny_delete_permit, SIGNAL(clicked()), this, SLOT(deletePermit()));
  connect(deny_add_deny, SIGNAL(clicked()), this, SLOT(addDeny()));
  connect(deny_delete_deny, SIGNAL(clicked()), this, SLOT(deleteDeny()));
}
void DenyPage::toggle_anyone(bool){
  deny_list_permit->setEnabled(false);
  deny_add_permit->setEnabled(false);
  deny_delete_permit->setEnabled(false);
  
  deny_list_deny->setEnabled(false);
  deny_add_deny->setEnabled(false);
  deny_delete_deny->setEnabled(false);
}

void DenyPage::toggle_buddy(bool){
  deny_list_permit->setEnabled(true);
  deny_add_permit->setEnabled(true);
  deny_delete_permit->setEnabled(true);
  
  deny_list_deny->setEnabled(false);
  deny_add_deny->setEnabled(false);
  deny_delete_deny->setEnabled(false);
}

void DenyPage::toggle_ask(bool){
  deny_list_permit->setEnabled(false);
  deny_add_permit->setEnabled(false);
  deny_delete_permit->setEnabled(false);
  
  deny_list_deny->setEnabled(true);
  deny_add_deny->setEnabled(true);
  deny_delete_deny->setEnabled(true);
}
    
void DenyPage::addPermit(){
  bool ok = FALSE;
  QString user = QInputDialog::getText( tr( "Enter Buddy's Name" ), tr( "Please enter a buddy's name" ), QString::null, &ok, this );
  if ( ok && !user.isEmpty() ){
    deny_list_permit->insertStringList(user); 
  }
  permitChanged = 1;
}

void DenyPage::deletePermit(){
  if (deny_list_permit->currentItem()!=-1)
    deny_list_permit->removeItem(deny_list_permit->currentItem());
  permitChanged = 1;
}

void DenyPage::addDeny(){
  bool ok = FALSE;
  QString user = QInputDialog::getText( tr( "Enter Buddy's Name" ), tr( "Please enter a buddy's name" ), QString::null, &ok, this );
  if ( ok && !user.isEmpty() ){
    deny_list_deny->insertStringList(user); 
  }
  denyChanged = 1;
}
void DenyPage::deleteDeny(){
  if (deny_list_deny->currentItem()!=-1)
    deny_list_deny->removeItem(deny_list_deny->currentItem());
  denyChanged = 1;
}
    
// Put in data
void DenyPage::updateData(){
  permitChanged = 0;
  denyChanged = 0;
  int per = connection->permissions();
  if(per == 1)
    access_anyone->setChecked(true);
  if(per == 3)
    access_buddy->setChecked(true);
  if(per == 4)
    access_ask->setChecked(true);	
  TBuddyList permitList = connection->permitList();
  TBuddyList denyList = connection->denyList();
  deny_list_permit->clear();
  deny_list_deny->clear();
  QString userName = "";
  for(int i = 0; i < permitList.getCount(); i++) {
    userName = permitList.getName(i);
    deny_list_permit->insertStringList(userName);
  }
  for(int i = 0; i < denyList.getCount(); i++) {
    userName = denyList.getName(i);
    deny_list_deny->insertStringList(userName);
  }
}

// Get data and save
void DenyPage::getData(){
  TBuddyList permitList;
  TBuddyList denyList;
  QString userName = "";
  for (int i=0; i < deny_list_permit->numRows(); i++){
    userName = deny_list_permit->text(i);
    if (!!userName){
      TBuddy bud;
      bud.name = userName;
      permitList.add(&bud);
    }  
  }
  for (int i=0; i < deny_list_deny->numRows(); i++){
    userName = deny_list_deny->text(i);
    if (!!userName){
      TBuddy bud;
      bud.name = userName;
      denyList.add(&bud);
    }
  }
  if (permitChanged == 1)
    connection->setPermitList(permitList);
  if (denyChanged == 1)
    connection->setDenyList(denyList);

  if(access_anyone->isChecked()){
    if(connection->permissions() != 1)
      connection->setPermissions(1);
  }  
  if(access_buddy->isChecked()){
    if(connection->permissions() != 3)
      connection->setPermissions(3);
  }
  if(access_ask->isChecked()){
    if(connection->permissions() != 4)
      connection->setPermissions(4);
  }
}

void DenyPage::resizeEvent ( QResizeEvent * ) {
  int border_w = width()-20;

  access->setGeometry( 10, 10, border_w, 90 );

  deny->setGeometry( 10, 105, border_w, height()-115 );
  int list_w = (deny->width() / 2) - 30;
  int list_h = deny->height() - 75;
  int deny_x = deny->width()-(list_w+10);

  deny_list_permit->setGeometry( 10, 40, list_w, list_h );
  deny_add_permit->setGeometry( 10, list_h+45, 50, 22);
  deny_delete_permit->setGeometry( 70, list_h+45, 50, 22);

//  deny_split->setGeometry( (deny->width() / 2) - 5, 15, 10, deny->height()-25);

  deny_label->setGeometry( deny_x, 15, 60, 20 );
  deny_list_deny->setGeometry( deny_x, 40, list_w, list_h );
  deny_add_deny->setGeometry( deny_x, list_h+45, 50, 22);
  deny_delete_deny->setGeometry( deny_x+60, list_h+45, 50, 22);

}

/********************************************************
* Events Page
*********************************************************/

EventsPage::EventsPage( QWidget * parent, const char * name , settings *aimSettings)
  : QWidget( parent, name ){
}

void EventsPage::resizeEvent (QResizeEvent *) {
}

OkApplyCancelPanel::OkApplyCancelPanel( QWidget * parent, const char * name )
  : QWidget( parent, name )
{
	this->setFixedSize(450, 30);
  this->setMinimumSize(0,0);

  okButton= new QPushButton(this,"okButton");
  okButton->setGeometry(180,0,80,30);
  okButton->setMinimumSize(0,0);
  okButton->setText("&Ok");
  okButton->setDefault(true);

  applyButton= new QPushButton(this,"applyButton");
  applyButton->setGeometry(270,0,80,30);
  applyButton->setMinimumSize(0,0);
  applyButton->setText("&Apply");

  cancelButton= new QPushButton(this,"cancelButton");
  cancelButton->setGeometry(360,0,80,30);
  cancelButton->setMinimumSize(0,0);
  cancelButton->setText("Cancel");
  okButton->setFocus();

	connect(okButton, SIGNAL( clicked() ), this, SLOT( okButtonPressed() ));
	connect(applyButton, SIGNAL( clicked() ), this, SLOT(applyButtonPressed() ));
	connect(cancelButton, SIGNAL( clicked() ), this, SLOT(cancelButtonPressed()	));
}

void OkApplyCancelPanel::okButtonPressed( )
{
	emit( okPressed() );
}
void OkApplyCancelPanel::applyButtonPressed( )
{
	emit( applyPressed() );
}
void OkApplyCancelPanel::cancelButtonPressed( )
{
	emit( cancelPressed() );
}

void OkApplyCancelPanel::keyPressEvent(QKeyEvent *e){
  if(e->key() == Key_Escape){
    emit( cancelPressed() );
  }
}

	

//
#include "kaimdialogs.moc"
