/***************************************************************************
                               kaimdialogs.h
                             -------------------
    begin                : Sun Feb 13 01:05:24 EST 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 * Options Widget Brings up the setup widget that has tabs and allows you to
 * configure the program just about any way you want.
 * I added saving and putting in data and functionallity (Browse...)
 ***************************************************************************/

/*******************************************************************/
/* Original file by-                                               */
/* K Instant Messenger -- A KDE-based AOL Instant Messengr Client  */
/* Copyright (C) 1999 Aaron Traas and Jeremy Thompson              */
/*                                                                 */
/* For more information regaurding K Instant Messenger, contact:   */
/*    - EMAIL: adt6247@megahertz.njit.edu                          */
/*    - WWW:   http://www-ec.njit.edu/~adt6247/                    */
/*******************************************************************/

#ifndef KAIMDIALOGS_H 
#define KAIMDIALOGS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <qfiledialog.h>
#include <qtabdialog.h> 
#include <qevent.h> 
#include <qwidget.h>
#include <qbuttongroup.h> 
#include <qradiobutton.h> 
#include <qgroupbox.h> 
#include <qlineedit.h>
#include <qcheckbox.h> 
#include <qpushbutton.h>
#include <qlabel.h>
#include <qmultilinedit.h> 
#include <qlistbox.h>
#include <qcombobox.h>
#include <qinputdialog.h>
#include "taim.h"
#include "tbuddylist.h"

#include "kaimjanuswidget.h"
#include "chatoptionsimp.h"
#include "awayoptionsimp.h"
#include "mainwindowoptionsimp.h"
#include "profileoptionsimp.h"
#include "soundoptionsimp.h"
#include "networkoptionsimp.h"

#include "setup.h"

class DenyPage;
class EventsPage;
class OkApplyCancelPanel;
class ConfigWindow : public KaimJanusWidget //QTabDialog
{
  Q_OBJECT
	
  private slots:
    void sendData();
    void sendDataAndCloseDialog();
    void closeDialog();

  signals:
    void chatToolbarUpdated();
    void dataUpdated();
    void exiting();
    
  public:
    ConfigWindow( QWidget * parent=0, const char * name=0, settings *aimSettings=0, TAim *i_connection=0 );
    void updateData();

  private:
    SoundOptionsImp *sound;
    NetworkOptionsImp *network;
    AwayWindowOptionsImp *away;
    DenyPage *deny;
    ProfileOptionsImp *profile;
    ChatOptionsImp *chat;
    EventsPage *events;
		MainWindowOptionsImp *main;
		
    OkApplyCancelPanel *okPanel1, *okPanel2, *okPanel3, *okPanel4, *okPanel5, *okPanel6, *okPanel7, *okPanel8;
};


class DenyPage : public QWidget
{
  Q_OBJECT
public:
  DenyPage( QWidget * parent=0, const char * name=0 , settings *aimSettings=0 );
  void getData();
  void updateData();
  TAim *connection;
  
protected:
  void resizeEvent( QResizeEvent *e );

private:
	int permitChanged;int denyChanged;
        settings *i_aimSettings;
	QButtonGroup *access;
	QRadioButton *access_anyone;
	QRadioButton *access_buddy;
	QRadioButton *access_ask;

	QGroupBox *deny;
	QListBox *deny_list_permit;
	QListBox *deny_list_deny;
	QPushButton *deny_add_permit;
	QPushButton *deny_delete_permit;
	QPushButton *deny_add_deny;
	QPushButton *deny_delete_deny;
	QLabel *deny_label;

private slots:
  void toggle_anyone(bool);
  void toggle_buddy(bool);
  void toggle_ask(bool);
    
  void addPermit();
  void deletePermit();
  void addDeny();
  void deleteDeny();
};

//=================================

class EventsPage : public QWidget
{
	Q_OBJECT
public:
	EventsPage( QWidget * parent=0, const char * name=0, settings *aimSettings=0);
	void getData();
	void updateData();
	
protected:
	void resizeEvent(QResizeEvent *e);
	
private:
	QGroupBox *events;
	QListView *buddySelect;
	QListView *eventSelect;
	QPushButton *playSound;
	QPushButton *showDialog;
// TODO, Add functionality for docking
//	QPushButton *flashDockIcon;
};
	
	

//=================================

class OkApplyCancelPanel : public QWidget
{
	Q_OBJECT
public:
	OkApplyCancelPanel( QWidget * parent=0, const char * name=0 );
signals:
	void okPressed();
	void applyPressed();
	void cancelPressed();
private slots:
	void okButtonPressed();
	void applyButtonPressed();
	void cancelButtonPressed();
	void keyPressEvent(QKeyEvent *e);
private:
	QPushButton *okButton, *applyButton, *cancelButton;
};

#endif
// KAIMDIALOGS_H
