/***************************************************************************
                           mainwindowoptionsimp.cpp
                             -------------------
    begin                : Tuesday Jan 10 2001
    copyright            : (C) 2001 Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/


#include "mainwindowoptionsimp.h"
#include <qlineedit.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qspinbox.h>

/******************************************************************************
 * Constructor
 ******************************************************************************/
MainWindowOptionsImp::MainWindowOptionsImp(QWidget *parent, const char *name, settings *aimSettings) : MainWindowOptions ( parent,name,false ){
  i_aimSettings = aimSettings;
  resizeWidth->setChecked(true);
  resizeWidth->setChecked(false);
  resizeHeight->setChecked(true);
  resizeHeight->setChecked(false);
  noHeaders->hide();
}

/******************************************************************************
 * Deconstructor
 ******************************************************************************/
MainWindowOptionsImp::~MainWindowOptionsImp(){
}

/******************************************************************************
 * Copy the settings to the dialogs
 ******************************************************************************/
void MainWindowOptionsImp::updateData(){
	browser_other->setChecked(true);
  resizeHeight->setChecked(true);
	resizeWidth->setChecked(true);
  loginMoveRight->setChecked(true);

	resizeHeight->setChecked(i_aimSettings->main_resizeHeight);
  resizeHeightMax->setValue(i_aimSettings->main_resizeHeightMax);
  resizeHeightMin->setValue(i_aimSettings->main_resizeHeightMin);
  resizeWidth->setChecked(i_aimSettings->main_resizeWidth);
  resizeWidthMax->setValue(i_aimSettings->main_resizeWidthMax);
  resizeWidthMin->setValue(i_aimSettings->main_resizeWidthMin);
  if (i_aimSettings->main_loginMoveRight == true)
    loginMoveRight->setChecked(true);
  if (i_aimSettings->main_loginMoveLeft == true)
    loginMoveLeft->setChecked(true);
  if (i_aimSettings->main_loginMoveNo == true)
    loginMoveNo->setChecked(true);
  showIdle->setChecked(i_aimSettings->main_showIdle);
  showLastOn->setChecked(i_aimSettings->main_showLastOn);
  if (i_aimSettings->main_browser == "netscape")
		browser_netscape->setChecked(true);
	else if (i_aimSettings->main_browser == "konqueror")
		browser_konq->setChecked(true);
	else{
    browser_other->setChecked(true);
	  browser->setText(i_aimSettings->main_browser);
	}
	noButtons->setChecked(i_aimSettings->main_noIcons);

	
	loginMoveDown->setValue(i_aimSettings->main_moveDown);
  
	if (i_aimSettings->main_idleLayout == 1)
		loginIdleLayout1->setChecked(true);
  else
	  loginIdleLayout2->setChecked(true);
}

/******************************************************************************
 * Copy the settings to the dialogs
 ******************************************************************************/
void MainWindowOptionsImp::getData(){
  i_aimSettings->main_resizeHeight = resizeHeight->isChecked();
  i_aimSettings->main_resizeHeightMax = atoi(resizeHeightMax->text());
  i_aimSettings->main_resizeHeightMin = atoi(resizeHeightMin->text());
  i_aimSettings->main_resizeWidth = resizeWidth->isChecked();
  i_aimSettings->main_resizeWidthMax = atoi(resizeWidthMax->text());
  i_aimSettings->main_resizeWidthMin = atoi(resizeWidthMin->text());
  if (loginMoveRight->isChecked() == true)
    i_aimSettings->main_loginMoveRight = true;
  else
    i_aimSettings->main_loginMoveRight = false;
  if (loginMoveLeft->isChecked() == true)
    i_aimSettings->main_loginMoveLeft = true;
  else
    i_aimSettings->main_loginMoveLeft = false;
  if (loginMoveNo->isChecked() == true)
    i_aimSettings->main_loginMoveNo = true;
  else
    i_aimSettings->main_loginMoveNo = false;

  i_aimSettings->main_showIdle = showIdle->isChecked();
  i_aimSettings->main_showLastOn = showLastOn->isChecked();
  
	if (browser_netscape->isChecked() == true)
		i_aimSettings->main_browser = "netscape";
	if (browser_konq->isChecked() == true)
		i_aimSettings->main_browser = "konqueror";
  if (browser_other->isChecked() == true)
	  i_aimSettings->main_browser = browser->text();
  
	i_aimSettings->main_noIcons = noButtons->isChecked();
  
	i_aimSettings->main_moveDown = atoi(loginMoveDown->text());
  
	if (loginIdleLayout1->isChecked() == true)
	  i_aimSettings->main_idleLayout = 1;
	else
		i_aimSettings->main_idleLayout = 2;

}

// MainWindowOptionsImp.cpp
