/***************************************************************************
                             soundoptionsimp.cpp
                             -------------------
    begin                : Tuesday Jan 31 2001
    copyright            : (C) 2001 Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/


#include "soundoptionsimp.h"
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qwidget.h>

/******************************************************************************
 * Constructor
 ******************************************************************************/
SoundOptionsImp::SoundOptionsImp(QWidget *parent, const char *name, settings *aimSettings) : SoundOptions( parent,name,false ){
  i_aimSettings = aimSettings;
	connect(sound_browse_login, SIGNAL(clicked()), this, SLOT(setBuddyLoginClicked()));
  connect(sound_browse_logout, SIGNAL(clicked()), this, SLOT(setBuddyLogoutClicked()));
  connect(sound_browse_initial, SIGNAL(clicked()), this, SLOT(setInitialClicked()));
  connect(sound_browse_send, SIGNAL(clicked()), this, SLOT(setSendClicked()));
  connect(sound_browse_receive, SIGNAL(clicked()), this, SLOT(setReceiveClicked()));
}

/******************************************************************************
 * Deconstructor
 ******************************************************************************/
SoundOptionsImp::~SoundOptionsImp(){
}

/******************************************************************************
 * Copy the settings to the dialogs
 ******************************************************************************/
void SoundOptionsImp::updateData(){
  mode_soundcard->setChecked(true);
	
	if ( i_aimSettings->SoundMode == 0)
    mode_soundcard->setChecked(true);
  if ( i_aimSettings->SoundMode == 1)
    mode_beep->setChecked(true);
  if ( i_aimSettings->SoundMode == 2)
    mode_nosound->setChecked(true);
    
  sound_enable_login->setChecked(i_aimSettings->sound_enable_login);
  sound_enable_logout->setChecked(i_aimSettings->sound_enable_logout);
  sound_enable_initial->setChecked(i_aimSettings->chatSoundSettings->chat_sound_beepInitial);  
  sound_enable_receive->setChecked(i_aimSettings->chatSoundSettings->chat_sound_beepReceive);
  sound_enable_send->setChecked(i_aimSettings->chatSoundSettings->chat_sound_beepSend);
  sound_file_send->setText(i_aimSettings->chatSoundSettings->chat_sound_fileSend);
  sound_file_receive->setText(i_aimSettings->chatSoundSettings->chat_sound_fileReceive);
  sound_file_initial->setText(i_aimSettings->chatSoundSettings->chat_sound_fileInitial);
   
  sound_file_login->setText(i_aimSettings->sound_file_login);
  sound_file_logout->setText(i_aimSettings->sound_file_logout);
}

/******************************************************************************
 * Copy the settings to the dialogs
 ******************************************************************************/
void SoundOptionsImp::getData(){
  if ( mode_soundcard->isChecked()){
    i_aimSettings->SoundMode = 0;
    i_aimSettings->chatSoundSettings->chat_sound_playFile = true;
    i_aimSettings->chatSoundSettings->chat_sound = true;
  }	
  if ( mode_beep->isChecked()){
    i_aimSettings->SoundMode = 1;
    i_aimSettings->chatSoundSettings->chat_sound_playFile = false;
    i_aimSettings->chatSoundSettings->chat_sound = true;
  }  
  if ( mode_nosound->isChecked()){
    i_aimSettings->SoundMode = 2;
    i_aimSettings->chatSoundSettings->chat_sound_playFile = false;
    i_aimSettings->chatSoundSettings->chat_sound = false;
  } 
  i_aimSettings->chatSoundSettings->chat_sound_beepInitial =  sound_enable_initial->isChecked();
  i_aimSettings->chatSoundSettings->chat_sound_beepReceive = sound_enable_receive->isChecked();
  i_aimSettings->chatSoundSettings->chat_sound_beepSend = sound_enable_send->isChecked();
  i_aimSettings->chatSoundSettings->chat_sound_fileSend = sound_file_send->text();
  i_aimSettings->chatSoundSettings->chat_sound_fileReceive = sound_file_receive->text();
  i_aimSettings->sound_enable_login = sound_enable_login->isChecked();
  i_aimSettings->sound_enable_logout = sound_enable_logout->isChecked();
  i_aimSettings->sound_file_login = sound_file_login->text();
  i_aimSettings->sound_file_logout = sound_file_logout->text();
  i_aimSettings->chatSoundSettings->chat_sound_fileInitial = sound_file_initial->text();

  if ((sound_enable_receive->isChecked() == false) && (sound_enable_send->isChecked() == false))
    i_aimSettings->chatSoundSettings->chat_sound = false;
}

void SoundOptionsImp::setBuddyLoginClicked(){
  QString s( QFileDialog::getOpenFileName( QString(""),QString("*.wav *.au"),this, "Multimedia Files (*.au *.wav)") );
  if ( s.isEmpty()) return;
	else sound_file_login->setText(s);
}

void SoundOptionsImp::setBuddyLogoutClicked(){
  QString s( QFileDialog::getOpenFileName( QString(""),QString("*.wav *.au"),this, "Multimedia Files (*.au *.wav)") );
  if ( s.isEmpty()) return;
	else sound_file_logout->setText(s);
}

void SoundOptionsImp::setInitialClicked(){
  QString s( QFileDialog::getOpenFileName( QString(""),QString("*.wav *.au"),this, "Multimedia Files (*.au *.wav)") );
  if ( s.isEmpty()) return;
	else sound_file_initial->setText(s);
}

void SoundOptionsImp::setSendClicked(){
  QString s( QFileDialog::getOpenFileName( QString(""),QString("*.wav *.au"),this, "Multimedia Files (*.au *.wav)") );
  if ( s.isEmpty()) return;
	else sound_file_send->setText(s);
}

void SoundOptionsImp::setReceiveClicked(){
  QString s( QFileDialog::getOpenFileName( QString(""),QString("*.wav *.au"),this, "Multimedia Files (*.au *.wav)") );
  if ( s.isEmpty()) return;
	else sound_file_receive->setText(s);
}

// SoundOptionsImp.cpp
