/***************************************************************************
                                  setup.h
                             -------------------
    begin                : Thu Feb 17 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SETUP_H
#define SETUP_H

#include <qstring.h>
#include <qtextstream.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <stdlib.h>
#include <qdir.h>
#include <qmap.h>
#include <qmultilinedit.h>

#include "chatwindow.h"
	
struct settings {		
  QString config;
    
  // Sound
  int SoundMode;
  bool sound_enable_login;
  bool sound_enable_logout;
  QString sound_file_login;
  QString sound_file_logout;
 	
  // Network
  QString login_server_toc;
  QString login_server_login;
  QString login_port_toc;
  QString login_port_login;
  bool login_enable_save;					// In Use
  bool login_enable_auto;					// In Use
  QString login_name;					// In Use
  QString login_password;					// In Use
  int proxy_Choice;
  QString proxy_server;
  QString proxy_port;
  	
  // Permit Deny
 
  // Away
  bool away_enable_auto;
  int	away_auto_delay_minutes;
	int	away_auto_default_message;
  bool away_enable_ai;
  bool away_enable_info;
  bool away_disable_sound;				// In Use
  bool away_show_messageBox;
  //AwayMessages *listOfMessages;
	QMap <QString, QString> *mapAwayMessages;
		
  // Profile
  QMultiLineEdit *profile;
	
  // General
  bool main_resizeHeight;
	int main_resizeHeightMax;
	int main_resizeHeightMin;
	bool main_resizeWidth;
	int main_resizeWidthMax;
	int main_resizeWidthMin;
	bool main_loginMoveRight;
	bool main_loginMoveLeft;
	bool main_loginMoveNo;
	int main_moveDown;
	bool main_showIdle;
	bool main_showLastOn;
	QString main_browser;
	bool main_noIcons;
	int main_idleLayout;
	
	// Chat Settings
  chat_Settings *chatSettings;
  chat_Color_Settings *chatColorSettings;
  chat_Sound_Settings *chatSoundSettings;
  chat_ToolBar_Settings *chatToolBarSettings;

  QString IgnoreThisUpdate;
	// Internal Settings (not to be saved)
  QString Version;
  QString ReleaseDate;
  QString Language;
};

/**
  *@author Benjamin Meyer
  */

class setup {
	
  public:
    setup();
    ~setup();
    void save();
    void read();
    void saveBuddyList();
    void readBuddyList();
    void loadDefaults();
    settings *i_currentSettings;
};

#endif

// setup.h
