/***************************************************************************
       				signon.cpp
                             -------------------
    begin                : Sun Feb 13 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /***************************************************************************
 * Simple Three stage diogram that shows as Kaim connects to AOL.  Displays
 * fun little graphics and sets up TocConnection which passes the data to
 * the main window and out to BuddyList.
 ***************************************************************************/

#include "signon.h"
#include "kaimapplication.h"

/***************************************************************************
 * Constructor
 ***************************************************************************/
signOn::signOn(QWidget *parent, const char *name) : QWidget(parent,name){
  this->resize(240,220);
  this->setMinimumSize(240,220);
  this->setMaximumSize(240,220);

	cancel= new QPushButton(this,"NoName");
  cancel->setGeometry(70,180,100,30);
  cancel->setMinimumSize(0,0);
  cancel->setText("Cancel");

  image= new QLabel(this,"NoName");
  image->setGeometry(10,10,220,120);
  image->setMinimumSize(0,0);

  status= new QLabel(this,"NoName");
  status->setGeometry(10,140,220,30);
  status->setMinimumSize(0,0);
  status->setText("Not Connected");
  // Connect signals and slots.
  connect( cancel, SIGNAL(clicked()), this, SLOT(cancelButtonHit()));
}

/***************************************************************************
 * Deconstructor
 ***************************************************************************/
signOn::~signOn(){
}

void signOn::cancelButtonHit(){
  connection->setStatus(TAIM_OFFLINE);
  emit (cancelHit());
  connection->cancelProgress();
}


void signOn::initProgress(int, int, QString text){
  status->setText(text);
}

void signOn::updateProgress(int num, QString text){
  status->setText(text);
  if (num == 2)
    image->setBackgroundPixmap(Icon("connect2"));
  if (num == 5)
    image->setBackgroundPixmap(Icon("connect3"));
}

/***************************************************************************
 * Attempt to connect to the server.
 * Occurs when the window is brought up
 ***************************************************************************/
void signOn::Connect(){
  connect(connection, SIGNAL(initProgress(int, int, QString)), this, SLOT(initProgress(int, int, QString)));
  connect(connection, SIGNAL(updateProgress(int, QString)), this, SLOT(updateProgress(int, QString)));
	      
  	      
  connect(connection, SIGNAL(endProgress(void)), this, SIGNAL(connected(void)));
  // Change the image and text to the first of three
  image->setBackgroundPixmap(Icon("connect1"));	
  status->setText("Initializing connection to server");
	
  // dokeepAlive
  connection->doKeepAlive(true);
  // Idle
  connection->doIdleTime(true);
  // SetCustom server
  connection->useCustomServer(true);
  connection->setCustomServer(i_aimSettings->login_server_toc,atoi(i_aimSettings->login_port_toc),i_aimSettings->login_server_login,atoi(i_aimSettings->login_port_login));
  // Enable proxy
  if (i_aimSettings->proxy_Choice == 2){
    connection->useSocksServer(true);
    connection->setSocksProxy(i_aimSettings->proxy_server,atoi(i_aimSettings->proxy_port));
  }
  
  // Set UserName
  connection->setUserName( i_aimSettings->login_name );
  // set Pass
  connection->setPassword( i_aimSettings->login_password );
  // Set UserInfo
  connection->setUserInfo(i_aimSettings->profile->text());
  // setStatus(taim_online)
  connection->setStatus(TAIM_ONLINE);
  
  // Make the connections for this class.
  
  // Set image and text to number 2.  You only get this far if you can connect
}

// signon.cpp
#include "signon.moc"
