/***************************************************************************
                                  signon.h
                             -------------------
    begin                : Sun Feb 13 2000
    copyright            : (C) 2000 by Benjamin Meyer
    email                : benjamin@csh.rit.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 * Simple Three stage diogram that shows as Kaim connects to AOL.  Displays
 * fun little graphics and sets up TocConnection which passes the data to
 * the main window and out to BuddyList.
 ***************************************************************************/

#ifndef SIGNON_H
#define SIGNON_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>

#include <qdialog.h>
#include "taim.h"
#include "login.h"
#include "setup.h"


/**
  *@author Benjamin Meyer
  */

class signOn : public QWidget  {
  Q_OBJECT

  private slots:
    void cancelButtonHit();
    void initProgress(int, int, QString);
    void updateProgress(int, QString);
   
  signals:
    void cancelHit();
    void connected();
	
  public:
    settings *i_aimSettings;
    TAim *connection;
    void Connect();
    signOn(QWidget *parent=0, const char *name=0);
    ~signOn();
		
  protected:
    void initDialog();
    QPushButton *cancel;
    QLabel *image;
    QLabel *status;
};

#endif

// signon.h

